﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Media;

using Infragistics.Windows.Editors;

namespace CustomControls {

  [TemplatePart(Name = XamClearableComboEditor.ElementDropDownButton, Type = typeof(ToggleButton))]
  [TemplatePart(Name = XamClearableComboEditor.ElementClearButton, Type = typeof(Button))]
  public class XamClearableComboEditor : XamComboEditor {

    private Button clearButton;
    private ToggleButton dropDownButtonPrivate;

    static XamClearableComboEditor() {
      DefaultStyleKeyProperty.OverrideMetadata(typeof(XamClearableComboEditor), new FrameworkPropertyMetadata(typeof(XamClearableComboEditor)));
    }

    #region Constants

    private const string ElementDropDownButton = "PART_DropDownButton";
    private const string ElementClearButton = "PART_ClearButton";

    #endregion Constants


    public override void OnApplyTemplate()
    {
        base.OnApplyTemplate();

        var dropDownButton = this.Template.FindName(ElementDropDownButton, this) as ToggleButton;
        var clearButton = this.Template.FindName(ElementClearButton, this) as Button;


        if (clearButton != null)
        {
            if (clearButton != null)
            {
                clearButton.Click -= ClearValue;
                clearButton.Click += new RoutedEventHandler(ClearValue);
            }
        }
    }

    private void  ClearValue(object sender, RoutedEventArgs e) 
    {
      this.Value = null;
      this.Text = "";
      System.Diagnostics.Debug.WriteLine("clear");
    }

  }
}
